#include "testlib.h"

#include <bits/stdc++.h>

using namespace std;
using ll = long long int;

int n;
vector<int> m;

void readData() {
    n = inf.readInt();
    m.resize(n);
    for (int i = 0; i < n; ++i) {
        m[i] = inf.readInt();
    }
}

ll readAns(InStream &stream) {
    vector<int> a(n);
    ll ans = 0;
    for (int i = 0; i < n; ++i) {
        a[i] = stream.readInt(1, m[i], "a[" + vtos(i + 1) + "]");
        ans += a[i];
    }

    vector<pair<int, int>> pref_max(n);
    for (int i = 0; i < n; ++i) {
        pref_max[i] = {a[i], i};
        if (i) {
            pref_max[i] = max(pref_max[i], pref_max[i - 1]);
        }
    }

    vector<pair<int, int>> suff_max(n);
    for (int i = n - 1; i >= 0; --i) {
        suff_max[i] = {a[i], i};
        if (i != n - 1) {
            suff_max[i] = max(suff_max[i], suff_max[i + 1]);
        }
    }

    for (int i = 0; i < n; ++i) {
        if (a[i] < pref_max[i].first && a[i] < suff_max[i].first) {
            stream.quitf(
                _wa
                , "Three bad elements found: a[%d] = %d, a[%d] = %d, a[%d] = %d"
                , pref_max[i].second + 1
                , pref_max[i].first
                , i + 1
                , a[i]
                , suff_max[i].second + 1
                , suff_max[i].first
            );
        }
    }

    return ans;
}

int main(int argc, char* argv[]) {
    registerTestlibCmd(argc, argv);

    readData();

    ll jans = readAns(ans);
    ll pans = readAns(ouf);

    if (pans == jans) {
        quitf(_ok, "Answer is %lld", jans);
    } else if (pans < jans) {
        quitf(_wa, "Jury has a better answer %lld, participant answer is %lld", jans, pans);
    } else { // pans > jans
        quitf(_fail, "Participant has a better answer %lld, jury answer is %lld", pans, jans);
    }
}

