#include <climits>
#include <iostream>
#include <map>
#include <stack>
#include <vector>
using namespace std;
using ll = long long int;
using pii = pair<int, int>;


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n;
    cin >> n;

    vector<int> vec(n);
    vector<ll> left(n);
    vector<ll> right(n);

    for (auto& it : vec) {
        cin >> it;
    }

    stack<pii, vector<pii>> s;
    for (int i = 0; i < n; ++i) {
        pii cur = {vec[i], i};
        while (!s.empty() && s.top() >= cur) {
            s.pop();
        }

        if (s.empty()) {
            left[i] = 1LL * (i + 1) * vec[i];
        } else {
            int z = s.top().second;
            left[i] = left[z] + 1LL * (i - z) * vec[i];
        }
        s.push(cur);
    }

    while (!s.empty()) {
        s.pop();
    }
    
    for (int i = n - 1; i >= 0; --i) {
        pii cur = {vec[i], i};
        while (!s.empty() && s.top() >= cur) {
            s.pop();
        }

        if (s.empty()) {
            right[i] = 1LL * (n - i) * vec[i];
        } else {
            int z = s.top().second;
            right[i] = right[z] + 1LL * (z - i) * vec[i];
        }
        s.push(cur);
    }

    int top = 0;
    ll top_sum = 0;
    for (int i = 0; i < n; ++i) {
        ll cur = left[i] + right[i] - vec[i];
        if (cur > top_sum) {
            top_sum = cur;
            top = i;
        }
    }

    vector<int> ans(n);
    ans[top] = vec[top];
    for (int i = top + 1; i < n; ++i) {
        ans[i] = min(ans[i - 1], vec[i]);
    }
    for (int i = top - 1; i >= 0; --i) {
        ans[i] = min(ans[i + 1], vec[i]);
    }

    for (auto& it : ans) {
        cout << it << " ";
    }
    cout << endl;
}
