#include <iostream>
#include <map>
#include <climits>
#include <vector>
using namespace std;
using ll = long long int;
using pii = pair<int, int>;

int n;
vector<int> vec;
vector<int> ans;
map<pii, ll> calced;

int find_min(int l, int r) {
    int pos = l;
    for (int i = l + 1; i <= r; ++i) {
        if (vec[i] < vec[pos]) {
            pos = i;
        }
    }
    return pos;
}

ll calc(int l, int r) {
    if (l > r) {
        return 0;
    } else if (l == r) {
        return vec[l];
    } else {
        pii cur = {l, r};
        auto it = calced.find(cur);
        if (it != calced.end()) {
            return it->second;
        }
        
        int min_pos = find_min(l, r);
        ll left = 1LL * (min_pos - l + 1) * vec[min_pos] + calc(min_pos + 1, r);
        ll right = calc(l, min_pos - 1) + 1LL * (r - min_pos + 1) * vec[min_pos];
        return calced[{l, r}] = max(left, right);
    }
}

void restore(int l, int r) {
    if (l > r) {
        return;
    } else if (l == r) {
        ans[l] = vec[l];
    } else {
        int min_pos = find_min(l, r);
        ll left = 1LL * (min_pos - l + 1) * vec[min_pos] + calc(min_pos + 1, r);
        ll right = calc(l, min_pos - 1) + 1LL * (r - min_pos + 1) * vec[min_pos];

        if (left > right) {
            for (int i = l; i <= min_pos; ++i) {
                ans[i] = vec[min_pos];
            }
            restore(min_pos + 1, r);
        } else {
            for (int i = min_pos; i <= r; ++i) {
                ans[i] = vec[min_pos];
            }
            restore(l, min_pos - 1);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    cin >> n;
    vec.resize(n);
    ans.resize(n);
    for (auto& it : vec) {
        cin >> it;
    }

    calc(0, n - 1);
    restore(0, n - 1);
    for (auto& it : ans) {
        cout << it << " ";
    }
    cout << endl;
}
