#include <iostream>
#include <map>
#include <climits>
#include <vector>
using namespace std;
using ll = long long int;
using pii = pair<int, int>;

class tree {
public:
    tree(vector<int> vec)
        : vec{vec}
        , n{int(vec.size())}
    {
        t.resize(4 * n);
        build(1, 0, n - 1);
    }

    int get(int l, int r) const {
        return calc(1, 0, n - 1, l, r);
    }

private:
    int n;
    vector<int> t;
    const vector<int> vec;

    void build(int v, int l, int r) {
        if (l == r) {
            t[v] = l;
        } else {
            build(v * 2, l, (l + r) >> 1);
            build(v * 2 + 1, ((l + r) >> 1) + 1, r);
            t[v] = (vec[t[v * 2]] < vec[t[v * 2 + 1]] ? t[v * 2] : t[v * 2 + 1]);
        }
    }

    int calc(int v, int l, int r, int L, int R) const {
        if (l >= L && r <= R) {
            return t[v];
        }
        if (r < L || l > R) {
            return -1;
        }

        int a = calc(v * 2, l, (l + r) / 2, L, R);
        int b = calc(v * 2 + 1, (l + r) / 2 + 1, r, L, R);
        if (a == -1) {
            return b;
        }
        if (b == -1) {
            return a;
        }
        return vec[a] < vec[b] ? a : b;
    }
};

int n;
vector<int> vec;
vector<int> ans;
map<pii, ll> calced;

ll calc(int l, int r, const tree& t) {
    if (l > r) {
        return 0;
    } else if (l == r) {
        return vec[l];
    } else {
        pii cur = {l, r};
        auto it = calced.find(cur);
        if (it != calced.end()) {
            return it->second;
        }
        
        int min_pos = t.get(l, r);
        ll left = 1LL * (min_pos - l + 1) * vec[min_pos] + calc(min_pos + 1, r, t);
        ll right = calc(l, min_pos - 1, t) + 1LL * (r - min_pos + 1) * vec[min_pos];
        return calced[{l, r}] = max(left, right);
    }
}

void restore(int l, int r, const tree& t) {
    if (l > r) {
        return;
    } else if (l == r) {
        ans[l] = vec[l];
    } else {
        int min_pos = t.get(l, r);
        ll left = 1LL * (min_pos - l + 1) * vec[min_pos] + calc(min_pos + 1, r, t);
        ll right = calc(l, min_pos - 1, t) + 1LL * (r - min_pos + 1) * vec[min_pos];

        if (left > right) {
            for (int i = l; i <= min_pos; ++i) {
                ans[i] = vec[min_pos];
            }
            restore(min_pos + 1, r, t);
        } else {
            for (int i = min_pos; i <= r; ++i) {
                ans[i] = vec[min_pos];
            }
            restore(l, min_pos - 1, t);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    cin >> n;
    vec.resize(n);
    ans.resize(n);
    for (auto& it : vec) {
        cin >> it;
    }

    tree t = vec;
    calc(0, n - 1, t);
    restore(0, n - 1, t);
    for (auto& it : ans) {
        cout << it << " ";
    }
    cout << endl;
}
