#include "testlib.h"
#include <vector>
using namespace std;

const int MAX_N = 100 * 1000;
const int MAX_M = 1000 * 1000 * 1000;
const int MAX_K = 8;

//                  0       1       2       3       4       5
const int maxn[] = {MAX_N,  10,     MAX_N,  MAX_N,  MAX_N,  MAX_N};  
const int maxm[] = {MAX_M,  1000,   MAX_M,  MAX_M,  1000,   MAX_M};
const int maxk[] = {MAX_K,  MAX_K,  1,      2,      MAX_K,  MAX_K};

vector<pair<int, int>> event;

int main(int argc, char *argv[]) {
    registerValidation(argc, argv);
    int group = atoi(validator.group().c_str());
    int n = inf.readInt(1, maxn[group], "n");
    inf.readSpace();
    int m = inf.readInt(1, maxm[group], "m");
    inf.readSpace();
    int k = inf.readInt(1, maxk[group], "k");
    inf.readEoln();
    for (int i = 0; i < n; ++i) {
        int L = inf.readInt(1, m, "L_i");
        inf.readSpace();
        int R = inf.readInt(L, m, "R_i");
        inf.readEoln();
        event.emplace_back(L, 1);
        event.emplace_back(R + 1, -1);
    }
    
    sort(event.begin(), event.end());
    int cur_balance = 0;
    for (auto [coord, chg] : event) {
        cur_balance += chg;
        ensuref(
            cur_balance <= k
            , "in %d intersection %d is bigger than k = %d"
            , coord
            , cur_balance
            , k
        );
    }
    
    
    inf.readEof();
}
