#include <stdio.h>
#include <iostream>
#include <stdlib.h>
#include <string>
#include <string.h>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <assert.h>
#include <algorithm>
#include <iomanip>
#include <time.h>
#include <math.h>
#include <bitset>

#pragma comment(linker, "/STACK:256000000")

using namespace std;

typedef long long int ll;
typedef long double ld;

const int INF = 1000 * 1000 * 1000 + 21;
const ll LLINF = (1ll << 60) + 5;
const int MOD = 1000 * 1000 * 1000 + 7;

const int MAX_N = 1000 * 1000 + 228;
const int MAX_K = 8;

struct ev {
    int x;
    int type;
    int id;
};

bool operator<(const ev& a, const ev& b) {
    return a.x < b.x || (a.x == b.x && a.type < b.type);
}

int n, m, k;
int ln[MAX_N];
ev evs[2 * MAX_N];
int dp[1 << MAX_K];
vector<int> odd;

int main() {
#ifdef CH_EGOR
    freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#else
    //freopen("", "r", stdin);
    //freopen("", "w", stdout);
#endif

    scanf("%d%d%d", &n, &m, &k);
    for (int i = 0; i < n; ++i) {
        int l, r;
        scanf("%d%d", &l, &r);
        evs[2 * i] = {l, 1, i};
        evs[2 * i + 1] = {r + 1, -1, i};
    }
    sort(evs, evs + 2 * n);

    for (int i = 0; i < (1 << k); ++i) {
        dp[i] = -INF;
        if (__builtin_popcount(i) & 1) {
            odd.push_back(i);
        }
    }
    dp[0] = 0;

    int last = 0;
    int bl = -1;
    for (int i = 0; i < 2 * n; ++i) {
        for (int x : odd) {
            if (dp[x] != -INF) {
                dp[x] += evs[i].x - last;
            }
        }
        last = evs[i].x;

        if (evs[i].type == 1) {
            ++bl;
            assert(bl < k);
            int now = ln[evs[i].id] = bl;
            for (int j = 0; j < (1 << k); ++j) {
                if (!((j >> now) & 1)) {
                    dp[j ^ (1 << now)] = dp[j];
                }
            }
        } else {
            --bl;
            int now = ln[evs[i].id];
            for (int j = (1 << k) - 1; j >= 0; --j) {
                if ((j >> now) & 1) {
                    dp[j ^ (1 << now)] = max(dp[j ^ (1 << now)], dp[j]);
                    dp[j] = -INF;
                }
            }
        }
    }

    printf("%d\n", dp[0]);

    return 0;
}

