#include <iostream>
#include <algorithm>
#include <vector>
#include <random>
#include <time.h>
using namespace std;

const int INF = 1e9;

const int N = 1.1e5, K = 10;
const int T = 1 << 18;
const int TT = T * 2 + 229;

int n, m, k;
int L[N], R[N];

struct seg_tree {
    vector<int> coor;
    int sum[TT];
    bool mod[TT];

    void push(int i, int sz) {
        if (!mod[i]) return;
        if (i < T) {
            mod[i * 2] ^= 1;
            mod[i * 2 + 1] ^= 1;
        }
        mod[i] = false;
        sum[i] = sz - sum[i];
    }

    void chg(int i, int L, int R, int Ln, int Rn) {
        push(i, coor[R] - coor[L]);
        if (Rn <= coor[L] || coor[R] <= Ln) return;
        if (Ln <= coor[L] && coor[R] <= Rn) {
            mod[i] = true;
            push(i, coor[R] - coor[L]);
            return;
        }
        int M = (L + R) >> 1;
        chg(i * 2,     L, M, Ln, Rn);
        chg(i * 2 + 1, M, R, Ln, Rn);
        sum[i] = sum[i * 2] + sum[i * 2 + 1];
    }
} box;

int max_ans = 0;
mt19937 rnd(239);

vector<int> order;

int main() {
    ios::sync_with_stdio(false);
    cin >> n >> m >> k;
    for (int i = 0; i < n; ++i) {
        cin >> L[i] >> R[i];
        ++R[i];
        order.push_back(i);
        box.coor.push_back(L[i]);
        box.coor.push_back(R[i]);
    }
    sort(box.coor.begin(), box.coor.end());
    box.coor.resize(T + 1, box.coor.back());
    for (int i = 0; i < n; ++i) {
        if (rnd() & 1) {
            box.chg(1, 0, T, L[i], R[i]);
        }
        if (max_ans < box.sum[1]) {
            max_ans = box.sum[1];
        }
    }
    while (1. * clock() / CLOCKS_PER_SEC < 0.8) {
        shuffle(order.begin(), order.end(), rnd);
        bool chg = false;
        for (auto i : order) {
            int old_ans = box.sum[1];
            box.chg(1, 0, T, L[i], R[i]);
            int new_ans = box.sum[1];
            if (new_ans < old_ans) {
                box.chg(1, 0, T, L[i], R[i]);
            }
            if (new_ans > old_ans) {
                chg = true;
            }
        }
        if (!chg) {
            for (int i = 0; i < n; ++i) {
                if (rnd() & 1) {
                    box.chg(1, 0, T, L[i], R[i]);
                }
                if (max_ans < box.sum[1]) {
                    max_ans = box.sum[1];
                }
            }
        }
        if (max_ans < box.sum[1]) {
            max_ans = box.sum[1];
        }
    }
    cout << max_ans << '\n';
}
