#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,avx,avx2")

#include <stdio.h>
#include <iostream>
#include <stdlib.h>
#include <string>
#include <string.h>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <assert.h>
#include <algorithm>
#include <iomanip>
#include <time.h>
#include <math.h>
#include <bitset>

#pragma comment(linker, "/STACK:256000000")

using namespace std;

typedef long long int ll;
typedef long double ld;

const int INF = 1000 * 1000 * 1000 + 21;
const ll LLINF = (1ll << 60) + 5;
const int MOD = 1000 * 1000 * 1000 + 7;

const int MAX_N = 1000 * 1000 + 228;

unsigned int n, m;
char a[MAX_N];
char b[MAX_N];
char s[MAX_N];
char cp[2 * MAX_N];

template<typename T>
class TSolver {
public:
    T z[2 * MAX_N];

    void solve() {
        memcpy(cp, s, sizeof(char) * m);
        cp[m] = '$';
        memcpy(cp + m + 1, b, sizeof(char) * n);
        reverse(cp, cp + m);
        reverse(cp + m + 1, cp + m + n + 1);

        unsigned int sz = m + n + 1;
        for (unsigned int i = 1, l = 0, r = 0; i < sz; ++i) {
            if (i <= r) {
                z[i] = min(r - i + 1, (unsigned int)z[i - l]);
            }
            while (i + z[i] < sz && cp[z[i]] == cp[i + z[i]]) {
                ++z[i];
            }
            if (i + z[i] - 1 > r) {
                l = i;
                r = i + z[i] - 1;
            }
        }
        for (unsigned int i = m + 1; i < sz; ++i) {
            z[i - m - 1] = z[i];
        }
        reverse(z, z + n);

        ll ans = 0;
        for (unsigned int l1 = 0; l1 < n; ++l1) {
            for (unsigned int r1 = l1, target = min(n, l1 + m - 1u); r1 < target; ++r1) {
                if (s[r1 - l1] != a[r1]) {
                    break;
                }
                const T sz = m - (r1 - l1 + 1);
                for (unsigned int r2 = max(l1, sz - 1u), target = min(n, r1 + sz); r2 < target; ++r2) {
                    if (z[r2] >= sz) {
                        ++ans;
                    }
                }
            }
        }

        printf("%lld\n", ans);
    }
};

TSolver<unsigned short> shortSolver;
TSolver<unsigned int> intSolver;

int main() {
#ifdef CH_EGOR
    freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#else
    //freopen("", "r", stdin);
    //freopen("", "w", stdout);
#endif

    scanf("%u%u", &n, &m);
    scanf("%s", a);
    scanf("%s", b);
    scanf("%s", s);

    if (m < (1 << 16)) {
        shortSolver.solve();
    } else {
        intSolver.solve();
    }

    return 0;
}

