#include <stdio.h>
#include <iostream>
#include <stdlib.h>
#include <string>
#include <string.h>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <assert.h>
#include <algorithm>
#include <iomanip>
#include <time.h>
#include <math.h>
#include <bitset>

#pragma comment(linker, "/STACK:256000000")

using namespace std;

typedef long long int ll;
typedef long double ld;

const int INF = 1000 * 1000 * 1000 + 21;
const ll LLINF = (1ll << 60) + 5;
const int MOD = 1000 * 1000 * 1000 + 7;

const int MAX_N = 1000 * 1000 + 228;

int n, m;
char a[MAX_N];
char b[MAX_N];
char s[MAX_N];
char cp[2][2 * MAX_N];
int z[2][2 * MAX_N];
int fen[2][MAX_N];
vector<pair<int, int>> evs;

void calc_z(char st[], char cp[], int z[], bool need_rev) {
    memcpy(cp, s, sizeof(char) * m);
    cp[m] = '$';
    memcpy(cp + m + 1, st, sizeof(char) * n);

    if (need_rev) {
        reverse(cp, cp + m);
        reverse(cp + m + 1, cp + m + n + 1);
    }

    int sz = m + n + 1;
    for (int i = 1, l = 0, r = 0; i < sz; ++i) {
        if (i <= r) {
            z[i] = min(r - i + 1, z[i - l]);
        }
        while (i + z[i] < sz && cp[z[i]] == cp[i + z[i]]) {
            ++z[i];
        }
        if (i + z[i] - 1 > r) {
            l = i;
            r = i + z[i] - 1;
        }
    }

    for (int i = m + 1; i < sz; ++i) {
        z[i - m - 1] = z[i];
    }

    if (need_rev) {
        reverse(z, z + n);
    }
}

void upd(int fen[], int x, int val) {
    for (; x <= n; x = (x | (x + 1))) {
        fen[x] += val;
    }
}

int get(int fen[], int x) {
    int ans = 0;
    for (; x > -1; x = (x & (x + 1)) - 1) {
        ans += fen[x];
    }

    return ans;
}

int get_interval(int fen[], int l, int r) {
    return get(fen, r) - get(fen, l - 1);
}

int main() {
#ifdef CH_EGOR
    freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#else
    //freopen("", "r", stdin);
    //freopen("", "w", stdout);
#endif

    scanf("%d%d", &n, &m);
    scanf("%s", a);
    scanf("%s", b);
    scanf("%s", s);

    calc_z(a, cp[0], z[0], false);
    calc_z(b, cp[1], z[1], true);

    for (int i = 0; i < n; ++i) {
        upd(fen[0], i + 1, 1);
        evs.push_back({z[0][i] + 1, -i - 1});
        evs.push_back({m - min(z[1][i], m - 1), i + 1});
    }

    sort(evs.begin(), evs.end());

    ll ans = 0;
    ll cur = 0;
    int ptr = 0;
    for (int i = 1; i < m; ++i) {
        while (ptr < (int)evs.size() && evs[ptr].first == i) {
            int at = evs[ptr++].second;

            if (at < 0) {
                upd(fen[0], -at, -1);
                cur -= get_interval(fen[1], -at, min(n, -at + m - 2));
            } else {
                upd(fen[1], at, 1);
                cur += get_interval(fen[0], max(0, at - m + 2), at);
            }
        }

        ans += cur;
    }

    printf("%lld\n", ans);

    return 0;
}

